tweak_data.weapon.contraband_m203.CLIP_AMMO_MAX = 1
tweak_data.weapon.contraband_m203.AMMO_MAX = 8
tweak_data.weapon.contraband_m203.stats.reload = math.floor(tweak_data.weapon.contraband_m203.stats.reload * 1.10)

function WeaponUnderbarrelLauncher:init(unit)
	WeaponUnderbarrelLauncher.super.init(self, unit)
	self._name_id = self.name_id
	self._damage = 500 -- tweak_data.weapon[self._name_id].stats.damage/10
	self.damage = self._damage
	self._rays = 20 
	self._damage_near = 2000
	self._damage_far = 3000
end

function WeaponUnderbarrelLauncher:get_name_id()
	return self._name_id
end

function WeaponUnderbarrelLauncher:weapon_tweak_data()
	return tweak_data.weapon[self._name_id]
end

function WeaponUnderbarrelLauncher:armor_piercing_chance()
	return 1
end

function WeaponUnderbarrelLauncher:got_silencer()
	return self._silencer
end

function WeaponUnderbarrelLauncher:get_current_weapon()
	local current_selected = managers.player:player_unit():inventory()._equipped_selection or 2
	return managers.player:player_unit():inventory()._available_selections[current_selected].unit
end

local mvec_spread_direction = Vector3()
local mvec_to = Vector3()
function WeaponUnderbarrelLauncher:_fire_raycast(weapon_base, user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul, shoot_through_data)
	local result = {}
	local hit_enemies = {}
	local damage = self._damage
	local function hit_enemy(col_ray)
		if col_ray.unit:character_damage() and col_ray.unit:character_damage().is_head then
			local enemy_key = col_ray.unit:key()
			if not hit_enemies[enemy_key] or col_ray.unit:character_damage():is_head(col_ray.body) then
				hit_enemies[enemy_key] = col_ray
			end
		else
			InstantBulletBase:on_collision(col_ray, self:get_current_weapon(), user_unit, damage)
		end
	end
	local right = direction:cross(Vector3(0, 0, 1)):normalized()
	local up = direction:cross(right):normalized()
	for ray = 1, self._rays or 20 do
		local spread_x = 5.5
		local spread_y = 5.5
		local theta = math.random() * 360
		local ax = math.sin(theta) * (math.random() * spread_x) * (spread_mul or 1)
		local ay = math.cos(theta) * (math.random() * spread_y) * (spread_mul or 1)
		mvector3.set(mvec_spread_direction, direction)
		mvector3.add(mvec_spread_direction, right * math.rad(ax))
		mvector3.add(mvec_spread_direction, up * math.rad(ay))
		mvector3.set(mvec_to, mvec_spread_direction)
		mvector3.multiply(mvec_to, 20000)
		mvector3.add(mvec_to, from_pos)
		local col_ray = World:raycast("ray", from_pos, mvec_to, "slot_mask", InstantBulletBase:bullet_slotmask(), "ignore_unit", {})
		if col_ray then
			hit_enemy(col_ray)
		end
	end
	for _, col_ray in pairs(hit_enemies) do
		local dist = mvector3.distance(col_ray.unit:position(), user_unit:position())
		damage = (1 - math.min(1, math.max(0, dist - self._damage_near) / self._damage_far)) * damage
		local result = InstantBulletBase:on_collision(col_ray, self:get_current_weapon(), user_unit, damage)
		if result and result.type == "death" and col_ray.distance < 500 then
			if col_ray.unit:movement()._active_actions[1] and col_ray.unit:movement()._active_actions[1]:type() == "hurt" then
				col_ray.unit:movement()._active_actions[1]:force_ragdoll()
			end
			local scale = math.clamp(1 - col_ray.distance / 500, 0.5, 1)
			local unit = col_ray.unit
			local height = mvector3.distance(col_ray.position, col_ray.unit:position()) - 100
			local twist_dir = math.random(2) == 1 and 1 or -1
			local rot_acc = (col_ray.ray:cross(math.UP) + math.UP * (0.5 * twist_dir)) * (-1000 * math.sign(height))
			local rot_time = 1 + math.rand(2)
			local nr_u_bodies = unit:num_bodies()
			local i_u_body = 0
			while nr_u_bodies > i_u_body do
				local u_body = unit:body(i_u_body)
				if u_body:enabled() and u_body:dynamic() then
					local body_mass = u_body:mass()
					World:play_physic_effect(Idstring("physic_effects/shotgun_hit"), u_body, Vector3(col_ray.ray.x, col_ray.ray.y, col_ray.ray.z + 0.5) * 600 * scale, 4 * body_mass / math.random(2), rot_acc, rot_time)
				end
				i_u_body = i_u_body + 1
			end
		end
	end
	result.hit_enemy = next(hit_enemies) and true or false
	weapon_base:check_bullet_objects()
	return result
end